@ blinken3b.s   Blinken lassen von 3 LEDs als Binaerzaehler (Loesung von Uebung1 u. 2)
.equ LINUX_VERSION, 1  @ auskommentieren fuer "bare-metal"
@.equ OHNE_TIMER, 1     @ auskommentieren wenn Timer verwendet werden soll

.ifdef LINUX_VERSION
        .text
        .global meinunterprogramm
meinunterprogramm:
        push {r1-r12,lr}
        mov r7, r0
        ldr r8, adrTimeradr  @ Adresse der Adresse laden
        str r1, [r8,#0]      @ Timer-Basisadresse in Timeradr speichern
        bl meinstart
        mov r0, #123         @ Rueckgabewert
        pop {r1-r12,pc}
meinstart:
.else
        .section .init
        .text
        .global _start
_start:
        mov sp, #0x8000           @ Stack Pointer setzen
        mov r7, #0x20000000
        add r7, #0x200000         @ GPIO-Adresse im r7 behalten
.endif
	push {lr}                 @ (nur mit Linux wirklich gebraucht)
        bl gpio_initialisieren
        ldr r0, Wartezeit
        mov r6, #0                @ Beim Start alle 3 LEDs aus
	mov r1, #120	          @ Schlaufenzaehler (nur mit Linux wirklich gebraucht)
L1:     bl leds_gemaess_r6_schalten
        bl pause
        add r6, #1
        and r6, #0b111            @ nur unterste 3 Bits behalten
.ifdef LINUX_VERSION
	subs r1, #1               @ Schlaufenzaehler erniedrigen
        bne L1                    @ ungleich 0 --> naechster Durchlauf
	pop {lr}		  @ Ruecksprung
.else
	b L1
.endif

Wartezeit: .word 500000       @ 0.5 Sekunden, also 1 Hz Blinkfrequenz

gpio_initialisieren:    @ 3 am GPIO angeschlossene LEDs auf Ausgang setzen
        push {r0,lr}         @ Register retten
        mov r0, #(1<<(6*3))  @ GPIO16 gruen OK-LED
        add r0, #(1<<(7*3))  @ GPIO17 rote LED
        str r0, [r7,#4]      @ benutzte GPIO im Bereich 10-19 setzen
        mov r0, #(1<<(7*3))  @ GPIO27 gelbe LED
        str r0, [r7,#8]      @ benutzte GPIO im Bereich 20-29 setzen
        pop {r0,pc}          @ gerettete Register zurueckholen, und Ruecksprung

        .data
Timeradr:
        .word 0x20003000    @ Timer-Basis-Adresse als konstanter Zahlenwert
        .text
adrTimeradr:
        .word Timeradr      @ die Adresse der Adresse des Timers

.ifdef OHNE_TIMER
pause:  @ Variante ohne Timer, Aufrufparameter: r0 = soviele Microsekunden warten
	push {r0,lr}
        lsl r0, #4           @ mit 16 multiplizieren fuer ungefaehr richtige Verzoegerung
L3:
        subs r0, #1          @ Schlaufe braucht ungefaehr 0.1 Microsekunden
        bne L3               @ Springe wenn Endzeitpunkt noch nicht erreicht ist
	pop {r0,pc}
.else
pause:  @ Aufrufparameter: r0: soviele Microsekunden warten
        push {r4,r5,r8,lr}  @ Register retten
        ldr r8, adrTimeradr @ Adresse der Adresse laden
        ldr r8, [r8,#0]     @ Timer-Basisadresse laden
        ldr r4, [r8,#4]     @ Zaehler des Timers einlesen, nur untere 32-Bit
        add r4, r0          @ Endzeitpunkt berechnen
        str r4, [r8,#12]    @ speichern im Vergleichsregister "Compare 0"
        mov r5, #1          @ Zum das Bit rueckzusetzen wirklich eine 1 schreiben!
        str r5, [r8,#0]     @ Bit M0 im CS ruecksetzen
L3:     ldr r5, [r8,#0]     @ neuer Status abfragen
        tst r5, #1          @ ist M0 gesetzt?
        beq L3              @ nein-> warten bis gesetzt
        pop {r4,r5,r8,pc}   @ grettete Register zurueckholen, und Ruecksprung
.endif

leds_gemaess_r6_schalten:   @ r6 unterste 3 Bits: bei gesetztem Bit soll entsprechende LED leuchten
        push {r0,r1,r6,lr}  @ Register retten
        eor r6, #0xFF       @ alle Bits umkehren, da LEDs mit 0 eingeschaltet werden
        mov r0, #17         @ GPIO17 1. LED, rot
        mov r1, r6          @ 1. Bit ins r1 kopieren
        bl gpio_ein_aus
        mov r0, #27         @ GPIO27 2. LED, gelb
        mov r1, r6, lsr #1  @ 2. Bit ins r1 kopieren
        bl gpio_ein_aus
        mov r0, #16         @ GPIO16 3. LED, gruene ok-LED
        mov r1, r6, lsr #2  @ 3. Bit ins r1 kopieren
        bl gpio_ein_aus
        pop {r0,r1,r6,pc}   @ gerettete Register zurueckholen, und Ruecksprung

gpio_ein_aus:  @ Parameter: r0=Nummer, r1.bit0=Spannung ein/aus (0=aus, 1=ein), r7=GPIO-Basisadresse
        push {r2,lr}        @ Register retten
        mov r2, #1
        lsl r2, r0          @ r2 = (1<<r0)
        tst r1, #1          @ ist erstes Bit in r1 gleich Null?
        streq r2, [r7,#40]  @ ja: Spannung aus
        strne r2, [r7,#28]  @ nein: Spannung ein
        pop {r2,pc}         @ gerettete Register zurueckholen, und Ruecksprung
